package Mail::Mailer2;

=head1 NAME

Mail::Mailer2 - Simple interface to electronic mailing mechanisms 

=head1 SYNOPSIS

    use Mail::Mailer2;

    $mailer = new Mail::Mailer2;

    $mailer = new Mail::Mailer2 $type, @args;

    $mailer->open($recipients, \%headers);
    or
    $mailer->open(\@recipients, \%headers);

    print $mailer $body;

    $mailer->close;


=head1 DESCRIPTION

Mail::Maileropen᥽åɤ򥪡С饤ɤơͤToإåΩ
Ǥ褦ˤ$typeˤ'qmail', 'sendmail'ꤹ뤳Ȥ
롣

=cut

use strict;
use vars qw(@ISA);
require Mail::Mailer;

@ISA = qw(Mail::Mailer);

sub new {
    my($class, $type, @args) = @_;
    my $mailer = 'qmail2';

    if ($type eq 'sendmail'){
	$mailer = 'sendmail2';
    }

# Mail::MailernewƤ
    my $self = $class->SUPER::new($mailer, @args);

# ¹ԥե򥻥å(Mail::Mailerľܥ᥽åɡѿƤӽФ)
    *$self->{Exe} = Mail::Mailer::is_exe($Mail::Mailer::Mailers{$type});

    return $self;
}

sub open {
    my($self, $recipients, $hdrs) = @_;
    my $exe = *$self->{Exe}; # || Carp::croak "$self->open: bad exe";
    my $args = *$self->{Args};
# ľܸƤФͤФʤʤ
    Mail::Mailer::_cleanup_hdrs($hdrs);
    my @to = ref($recipients) ? @$recipients : ($recipients);

    $self->close;       # just in case;

    # Fork and start a mailer
    (defined($exe) && open($self,"|-"))
        || $self->exec($exe, $args, \@to)
        || die $!;

    # Set the headers
    $self->set_headers($hdrs);

    # return self (a FileHandle) ready to accept the body
    $self;
}

1;

__END__

=head1 RCSID

$Id: Mailer2.pm 136 2004-12-11 04:13:06Z mkoya $

=cut
