# ܸʸȽ
#
# $Id: Jcode.rb 136 2004-12-11 04:13:06Z mkoya $

module JCode
  J_0208 = {'1978' => '\e\$\@',
            '1983' => '\e\$B',
            '1990' => '\e&\@\e\$B'}
  RE = {'ASCII'     => '[\x00-\x7f]',
        'BIN'       => '[\x00-\x06\x7f\xff]',
        'EUC_0212'  => '\x8f[\xa1-\xfe][\xa1-\xfe]',
        'EUC_C'     => '[\xa1-\xfe][\xa1-\xfe]',
        'EUC_KANA'  => '\x8e[\xa1-\xdf]',
        'JIS_0208'  =>  "#{J_0208['1978']}|#{J_0208['1983']}|#{J_0208['1990']}",
      'JIS_0212'  => "\e" + '\$\(D',
        'JIS_ASC'   => "\e" + '\([BJ]',     
        'JIS_KANA'  => "\e" + '\(I',
        'SJIS_C'    => '[\x81-\x9f\xe0-\xfc][\x40-\x7e\x80-\xfc]',
        'SJIS_KANA' => '[\xa1-\xdf]',
        'UTF8'      => '[\xc0-\xdf][\x80-\xbf]|[\xe0-\xef][\x80-\xbf][\x80-\xbf]'}

  def JCode::max(*data)
    ret = nil
    data.each do |datum|
      if ret then
        ret = datum if ret < datum
      else
        ret = datum
      end
    end
    ret
  end

  def getcode(str)
    code, nmatch, sjis, euc, utf8 = nil, 0, 0, 0, 0

    if /#{RE['BIN']}/o =~ str
      ucs2 = 0
      str.gsub(/(\x00#{RE['ASCII']})+/) do |matched|
        ucs2 += matched.length
      end
      if ucs2!=0      # smells like raw unicode 
        code, nmatch = 'ucs2', ucs2
      else
        code, nmatch = 'binary', 0
      end
    elsif /[\e\x80-\xff]/o !~ str	# not Japanese
      code, nmatch = 'ascii', 1
      # 'jis'
    elsif /#{RE['JIS_0208']}|#{RE['JIS_0212']}|#{RE['JIS_ASC']}|#{RE['JIS_KANA']}/o =~ str
	code, nmatch = 'jis', 1
    else  # should be euc|sjis|utf8
      str.gsub(/(#{RE['SJIS_C']})+/) do |matched|
        sjis = matched.length
      end
      str.gsub(/(#{RE['EUC_C']}|#{RE['EUC_KANA']}|#{RE['EUC_0212']})+/) do |matched|
        euc= matched.length
      end
      str.gsub(/(#{RE['UTF8']})+/) do |matched|
	utf8  = matched.length
      end
      nmatch = max(utf8, sjis, euc)
      code = 
	    (euc > sjis and euc > utf8) ? 'euc' :
		(sjis > euc and sjis > utf8) ? 'sjis' :
		    (utf8 > euc and utf8 > sjis) ? 'utf8' : nil
    end
    return code
  end
  module_function :getcode
end
