# GnuPGư
#
# $Id: gnupg.rb 298 2005-01-31 12:20:51Z mkoya $

class GnuPG
  def initialize(opt=nil)
    @quiet = @batch = @armor = @sign = false
    @passphrase = @defaultkey = @outfile = nil
    if opt
      opt.each do |key,value|
        @quiet = value if key == 'quiet'
        @batch = value if key == 'batch'
        @armor = value if key == 'armor'
        @sign  = value if key == 'sign'
        @passphrase = value if key == 'passphrase'
        @defaultkey = value if key == 'defaultkey'
        @outfile    = value if key == 'outfile'
      end
    end
  end
  attr_accessor :quiet
  attr_accessor :batch
  attr_accessor :armor
  attr_accessor :sign
  attr_accessor :passphrase
  attr_accessor :defaultkey
  attr_accessor :outfile
  def encrypt(recipients)
    @outfile = tmpfilename() unless @outfile
    command = 'gpg --encrypt'
    command += ' --quiet' if @quiet
    command += ' --batch' if @batch
    command += ' --armor' if @armor
    command += ' --sign' if @sign
    command += ' --passphrase-fd 0' if @sign && @passphrase
    command += " --default-key #{@defaultkey}" if @sign && @defaultkey
    recipients.each do |recipient|
      command += " --recipient #{recipient}"
    end
    command += " -o #{@outfile}"
    p command if $DEBUG
    @in = IO.popen(command, "w")
    @in.print "#{@passphrase}\n" if @sign && @passphrase
  end
  def print(*list)
    @in.print *list
  end
  def close
    @in.close
  end
  def result(out)
    tmp = open @outfile, "r"
    while msg = tmp.gets do
      out.print msg
    end
    tmp.close
    File.delete(@outfile)
  end
  def tmpfilename
    dir = "/tmp"

    dir = ENV['TMPDIR'] if ENV['TMPDIR']
    dir = ENV['GPGMAIL_TMPDIR'] if ENV['GPGMAIL_TMPDIR']

    "#{dir}/gnupg.rb.#{$$}"
  end
  private :tmpfilename
end
