#! /usr/local/bin/ruby

require 'inifiles'
require 'optparse'
require 'ostruct'
require 'gnupg'
require 'mailer'
require 'Jcode'

PROGNAME = File.basename($0)
PACKAGE_VERSION = '@VERSION@'
PACKAGE = '@PACKAGE@'
AUTHOR = '@AUTHOR@'
PACKAGE_BUGREPORT = '@PACKAGE_BUGREPORT@'

USAGE = "Usage: #{PROGNAME} [options] recipients [filename...]"

=begin
= NAME

gpgmail - Ź沽ƥ᡼

= SYNOPSIS

gpgmail [-pfOVh] [-c cfgfile] [-s subject] [-S sender] [-t to] [-l line]
[-g uids ] [-m mda] [--plain] [--config=cfgfile] [--subject=subject]
[--sender=sender] [--to=to] [--forward] [--sign] [--limit=line] [--gpgto=uids]
[--stdout] [--mda=mda]
[--help] [--usage] [--version]
recipients [filename...]

= DESCRIPTION

ɸϤޤϻΥեŹ沽ƥ᡼롣᡼ˤϥ
եȤqmail-injectȤ롣--mda=sendmailꤹsendmail
Ȥ롣

--stdoutץꤹȥ᡼ɸϤ˽Ϥ롣
qmailsendmailʳMDAȤäƤȤ˻Ȥ

recipientsˤϡޤǶڤäʣμͤǤ롣

--toץάȡTo:إårecipientsꤵ롣᡼
recipients롣--toץTo:إåϿ륢ɥ쥹
ꤹ롣--toץǻꤷɥ쥹ˤʤ

--gpgtoץάȡrecipientsθȤäưŹ沽롣

filenameʣꤷƤϢ뤵ƤҤȤĤΥ᡼Ȥ롣

ǥեȤǤϡ((*~/.gpgmail*))եȤƻȤ롣
եˤϡSender䤤ĤɲäإåեɤǤ롣
եƤ⡢ޥɥ饤󥪥ץͥ褵롣
((*dot.gpgmail*)) ץǤ롣

夷᡼򤹤٤ž롢((*~/.qmail*))

    ~/.qmailϡ

        &koyama-gpgmail@gvelo.ddnn.jp
        ./Maildir/

    Ȥơ~/.qmail-gpgmailgpgmailȤ

        |gpgmail --subject=gpgmail --forward mituru@gvelo.ddnn.jp

= OPTIONS

: -p, --plain

	Ź沽롣

: -c, --config=cfgfile

	configեꤹ롣ǥեȤ((*~/.gpgmail*))Ȥ롣

: -s, --subject=subject

	Subject:եɤꤹ롣ǥեȤǤSubject:إå
	ʤܸä硢MIME󥳡ɤ롣

: -S, --sender=sender

	senderꤹ롣ǥեȤǤqmailΥǥեȤȤ롣

: -t, --to=to

	To:եɤꤹ롣ǥեȤǤϡrecipientsȤ롣

: -f, --forward

	ŹʸȤMewžΤ褦ʷˤ롣

: --sign

	̾ưŹ沽롣

: -l, --limit=line

	žԿline¤롣0ʤ̵¡--forwardץ
	󤬻ꤵƤȡإåʬ򥫥Ȥʤ

: -g, --gpgto=uids

	Ź˻ȤUIDꤹ롣ޤǶڤäʣǤ롣

: -O, --stdout

	qmailޤsendmailɸϤ˽Ϥ롣qmail,
	sendmailʳMDAǤȤ褦ˤʤ롣

: -m, --mda=mda

	ץꤹ롣ǥեȤqmail¾sendmailȤ롣

: -?, --help

	ʰץإפϤ롣

: --usage

	ñʻˡɽ롣

: -V, --version

	ץΥСɽ롣

= ENVIRONMENTAL VARIABLES

: TMPDIR

	եǥ쥯ȥꡣǥեȤ((*/tmp*))

: GPGMAIL_TMPDIR

	եǥ쥯ȥꡣTMPDIRͥ褹롣

=end


##################################################################
# ץ
class Optparse
  def self.parse(args)
    options = OpenStruct.new
    options.cfgfile = "#{ENV['HOME']}/.gpgmail"
    options.plain = false
    options.subject = nil
    options.sender = nil
    options.to = nil
    options.forward = false
    options.sign = false
    options.limit = nil
    options.gpgto = nil
    options.stdout = false
    options.mda = nil
    opts = OptionParser.new do |opts|
      opts.banner = "#{USAGE}\nSend encrypted mail."
      opts.on('-c', '--config=CFGFILE',
              "config file [#{ENV['HOME']}/.gpgmail]"){ |v|
        options.cfgfile = v
      }
      opts.on('-p', '--plain', "not encrypt"){ |v| options.plain = v}
      opts.on('-s', '--subject=SUBJECT', "subject"){ |v| options.subject= v}
      opts.on('-S', '--sender=SENDER', "sender"){ |v| options.sender = v}
      opts.on('-t', '--to=TO', "To: header [recipients]"){ |v| options.to = v}
      opts.on('-f', '--forward', "forward format"){ |v| options.forward = v}
      opts.on(      '--sign', "sign and encrypt"){ |v| options.sign = v}
      opts.on('-l', '--limit=LINE', "send lines up to LINE"){ |v|
        options.limit = v
      }
      opts.on('-g', '--gpgto=UIDS', "crypt with uids [recipients]"){ |v|
        options.gpgto = v
      }
      opts.on('-O', '--stdout', "output to standard output"){ |v|
        options.stdout = v
      }
      opts.on('-m', '--mda=MDA', "program to send mails [qmail]"){ |v|
        options.mda = v
      }
      opts.on_tail('--usage', "Give a short usage message"){
        print "#{USAGE}\n"
        exit 0
      }
      opts.on_tail('-V', '--version', "Print program version"){
        print "#{PACKAGE} #{PACKAGE_VERSION}\n"
        print "Written by #{AUTHOR}.\n"
        exit 0
      }
      opts.on_tail("-?", "--help", "Show this message") {
        puts opts
        print "\nReport bugs to <#{PACKAGE_BUGREPORT}>.\n"
        exit 0
      }
    end
    opts.parse!(ARGV)
    options
  end
end

opts = Optparse.parse(ARGV)

recipient = ARGV.shift
unless recipient
    $stderr.print <<"EOT"
#{USAGE}
Try \`#{PROGNAME} --help\' or \`#{PROGNAME} --usage\' for more information.
EOT
    exit 1
end

##################################################################
# ե
cfg = IniFiles.new(opts.cfgfile)
headers = cfg.parameters('Headers')
opts.sender = cfg.val('Config', 'Sender') unless opts.sender
opts.mda = 'stdout' if opts.stdout
opts.mda = cfg.val('Config', 'MDA') unless opts.mda
opts.mda = 'qmail' unless opts.mda
opts.mdabin = cfg.val('Config', 'MDAbin');
if opts.sign
  ppfile = cfg.val('Config', 'PPFile')
  ppfile = ppfile.sub(%r!~/!, "#{ENV['HOME']}/")
  if ppfile
    f = File.open ppfile
    passphrase = f.gets
    passphrase.chomp!
    f.close
  end
  unless passphrase
    $stderr.print "Can't find passpharase.\n"
    exit 1
  end
  defaultkey = cfg.val('Config', 'DefaultKey')
end
delheaders = cfg.val('Forward', 'Delheaders') if opts.forward
delheaders = delheaders.split(/ /) if delheaders
opts.limit = opts.limit ? opt.limit.to_i : cfg.val('Config', 'Limit').to_i

##################################################################
# åɤ߹
msg = ""
lineno = 0
body = !opts.forward       # ž⡼ɤǤХإåϿʤ
delflag = false
while gets
  if opts.limit!=0 && lineno==opts.limit
    msg += "\n--- cut by gpgmail ---\n"
    break
  end
  if opts.forward && !body
    if delflag
      delflag = false
      delflag = true if /^[ \t]/ =~ $_
    end
    unless delflag
      delheaders.each do |head|
        delflag = true if /^#{head} /i =~ $_
      end
    end
  end
  msg += $_ unless delflag

  lineno += 1 if body        # Կ
  body = true if /^$/ =~ $_      # إåν
end

##################################################################
# åΥѴȥإåκ
code = JCode::getcode(msg)
if code == "euc" || code == "sjis"
    msg = msg.tojis
    code = "jis"
end

##################################################################
# ߻狼ʸ
def strbytime
  t = Time.now
  bodybound = t.strftime("--Next_Part(%a_%b_%d_%H:%M:%S_%Y_#{$$})--")
  gpgbound = t.strftime("--Security_Multipart(%a_%b_%d_%H:%M:%S_%Y_#{$$})--")
  date = t.strftime("%a, %d %b %Y %H:%M:%S %z (%Z)")
  return bodybound, gpgbound, date
end

bodybound, gpgbound, headers['Date'] = strbytime

##################################################################
# žѡȤ
if opts.forward
    msg = <<EOT
--#{bodybound}
Content-Type: Message/Rfc822
Content-Transfer-Encoding: 7bit
Content-Disposition: inline

#{msg}

--#{bodybound}--
EOT
end

# GnuPGʸ
unless opts.plain
  if opts.forward
    msg = <<EOT
Content-Type: Multipart/Mixed;
 boundary="#{bodybound}"
Content-Transfer-Encoding: 7bit

#{msg}
EOT
  elsif code == "jis"
    msg = <<EOT
Content-Type: Text/Plain; charset=iso-2022-jp
Content-Transfer-Encoding: 7bit

#{msg}
EOT
  else
    msg = <<EOT
Content-Type: Text/Plain; charset=us-ascii
Content-Transfer-Encoding: 7bit

#{msg}
EOT
  end
end

p msg if $DEBUG

##################################################################
# إåκ
recipients = recipient.split(/,/)
gpguids = recipients
gpguids = opts.gpgto.split(/,/) if opts.gpgto
headers['To'] = opts.to
headers['To'] = recipient unless headers['To']
headers['Subject'] = opts.subject if opts.subject
headers['MIME-Version'] = '1.0' unless headers['MIME-Version']
if opts.plain
  if opts.forward
    headers['Content-Type'] = "Multipart/Mixed; boundary=\"#{bodybound}\""
  elsif code == "jis"
    headers['Content-Type'] = "Text/Plain; charset=iso-2022-jp"
  else
    headers['Content-Type'] = "Text/Plain; charset=us-ascii"
  end
else
    headers['Content-Type'] = "Multipart/Encrypted; protocol=\"application/pgp-encrypted\"; boundary=\"#{gpgbound}\""
end
headers['Content-Transfer-Encoding'] = '7bit' unless headers['Content-Transfer-Encoding']
headers['X-Mailer'] = "gpgmail version #{PACKAGE_VERSION}"
p headers if $DEBUG

##################################################################
# Ź沽
unless opts.plain
  gnupg = GnuPG.new
  gnupg.batch = true
  gnupg.armor = true
  gnupg.sign = opts.sign
  gnupg.passphrase = passphrase
  gnupg.defaultkey = defaultkey
  gnupg.encrypt(gpguids)
  gnupg.print msg
  gnupg.close
end
p msg if $DEBUG

##################################################################
# ᡼饹
mailer = Mailer.new(opts.mda, opts.mdabin)
mailer.open(opts.sender, recipients, headers)

if opts.plain
  mailer.print $msg
else
  mailer.print <<EOT
--#{gpgbound}
Content-Type: application/pgp-encrypted
Content-Transfer-Encoding: 7bit

Version: 1

--#{gpgbound}
Content-Type: Application/Octet-Stream
Content-Transfer-Encoding: 7bit

EOT

  gnupg.result(mailer)

  mailer.print "\n--#{gpgbound}--\n"
end
mailer.close

=begin
= RCSID

$Id: gpgmail.rb 300 2005-02-10 16:52:40Z mkoya $

=end
