# եɤ߽
#
# $Id: inifiles.rb 136 2004-12-11 04:13:06Z mkoya $

class IniFiles
  def initialize(filename=nil)
    @data = {}
    return unless filename
    f = File.open(filename, "r")
    begin
      while s = f.gets do
        s.chomp!.strip!                                  
        next if s == ""
        next if s =~ /^[;#]/
        if s =~ /\[([^\]]+)\]/ then
          section = $1
          next
        end
        if s =~ /([^=\s]+)\s*=\s*(.*)/ then
          key, value = $1, $2
          set section, key, value
        end
      end
    ensure
      f.close
    end
  end
  def makeinifile(filename)
    f = File.open(filename, "w")
    begin
      @data.each do |section,item|
        f.print "[#{section}]\n"
        item.each do |key,value|
          f.print "#{key} = #{value}\n"
        end
        f.puts
      end
    ensure
      f.close
    end
  end
  def set(section, key, value)
    tmp = @data[section]
    if tmp then
      tmp.store(key, value)
    else
      tmp = {key => value}
    end
    @data.store(section, tmp)
  end
  def val(section, key)
    @data[section] && @data[section][key]
  end
  def parameters(section)
    @data[section]
  end
end
