# qmail-injectǥ᡼
# 
# $Id: mailer.rb 136 2004-12-11 04:13:06Z mkoya $

require 'kconv'
require 'Jcode'

class Mailer
  Mailers = {
    'qmail' \
    => [ "/usr/sbin/qmail-inject", "/var/qmail/bin/qmail-inject"], \
    'sendmail' \
    => [ "/usr/lib/sendmail", "/usr/sbin/sendmail", "/usr/ucblib/sendmail"], \
    'stdout' => nil
  }
  def initialize(mailer="qmail", mailbin=nil)
    if mailbin
      @cmd = mailbin
    else
      @cmd = is_exe(Mailers[mailer])
    end
  end
  def is_exe(mailers)
    return nil unless mailers
    mailers.each do |mailer|
      return mailer if FileTest.executable?(mailer)
    end
    return nil
  end
  def open(sender, recipients, headers)
    @in = STDOUT
    if @cmd
      @cmd += " -f#{sender}" if sender
      recipients.each do |recipient|
        @cmd += " #{recipient}"
      end
      @in = IO.popen(@cmd, "w")
    end
    headers.each do |key,value|
      if key =~ /subject/i then
        code = JCode::getcode(value)
        if code == "euc" || code == "sjis" || code == "jis"
          value = b64_encode(value)
          value = "=?ISO-2022-JP?B?#{value}?="
        end
      end
      @in.print "#{key}: #{value}\n" if value
    end
    @in.print "\n"
  end
  def print(*list)
    @in.print *list
  end
  def close
    @in.close
  end
  def b64_encode(str)
    estr = Kconv.tojis(str)
    estr = estr.split(//, 1).pack('m')
    estr = estr.chomp
  end
  private :b64_encode
end
